# coding: UTF-8
# grammatic.py
#
# library for: Cicero Open Project
# 

# PROGRAM CONSTATNTS
__version__='1.0.0'
__license__='GPL'
__author__='Cicero Develop Team'
__site__='www.cicero.glt.pl'

# IMPORTS
import string
import sys
import time
import xml_base_handling
import random
import global_direct as GD

from string import find, digits, rsplit
from time import time
from random import randint
from xml_base_handling import xml_load_base, xml_read_line, xml_split_line

# GLOBAL VARIABLES


# FUNCTIONS
def pronpun_declination():
	'''
	Deklinacha wybranych zaimkow

	'''
	personal_pronoun_1=['ego','mei','mihi','me','me','-','nos','nostri','nobis','nos','nobis','-']
	personal_pronoun_2=['tu','tui','tibi','te','te','-','vos','vestri','vobis','vos','vobis','-']
	personal_pronoun_1=['-','sui','sibi','se','se','-','-','sui','sibi','se','se','-']

	demonstrative_pronoun_1m=['is','eius','ei','eum','eo','-','ei','eorum','eis','eos','eis','-']
	demonstrative_pronoun_1f=['ea','eius','ei','eam','ea','-','eae','earum','eis','eas','eis','-']
	demonstrative_pronoun_1n=['id','eius','ei','id','eo','-','ea','eorum','eis','ea','eis','-']

	demonstrative_pronoun_2m=['hic','hunc','huius','huic','hoc','-','hi','hos','horum','his','his','-']
	demonstrative_pronoun_2f=['haec','hanc','huius','huic','hac','-','hae','has','harum','his','his','-']
	demonstrative_pronoun_2n=['hoc','huius','huic','hoc','hoc','-','haec','heac','horum','his','his','-']

	demonstrative_pronoun_3m=['ille','illum','illius','illi','illo','-','illi','illos','illorum','illis','illis','-']
	demonstrative_pronoun_3f=['illa','illam','illius','illi','illa','-','illae','illas','illarum','illis','illis','-']
	demonstrative_pronoun_3n=['illud','illud','illius','illi','illo','-','illa','illa','illorum','illis','illis','-']

	demonstrative_pronoun_4m=['idem','eiusdem','eidem','eumdem','eodem','-','iidem','eorundem','eisdem','eosdem','eisdem','-']
	demonstrative_pronoun_4f=['eadem','eiusdem','eidem','eandem','eadem','-','eaedem','eorundem','eisdem','easdem','eisdem','-']
	demonstrative_pronoun_4n=['idem','eiusdem','eidem','idem','eodem','-','eadem','eoryndem','eisdem','eadem','eisdem','-']

	demonstrative_pronoun_5m=['qui','cuius','cui','quem','quo','-','qui','quorum','quibus','quos','quibus','-']
	demonstrative_pronoun_5f=['quae','cuius','cui','quam','qua','-','quae','quarum','quibus','quas','quibus','-']
	demonstrative_pronoun_5n=['quod','cuius','cui','quod','quo','-','quae','quorum','quibus','quae','quibus','-']

	demonstrative_pronoun_4m=['','','','','','-','','','','','','-']
	demonstrative_pronoun_4f=['','','','','','-','','','','','','-']
	demonstrative_pronoun_4n=['','','','','','-','','','','','','-']

def equal_sound(nom=None, gen=None):
	'''
	Funkcja sprawdzajaca rownozgloskowosc wyrazow

	'''
	nom_counter=gen_counter=0
	if len(gen)<4:return(False)
	if nom==None:
		if (gen[-3] in ('aoeiyu') or gen[-4] in ('aoeiyu')):
			return(True)
	else:
		for i in range(len(nom)):
			if nom[i] in ('aoeiyu'):
				nom_counter+=1

		for i in range(len(gen)):
			if gen[i] in ('aoeiyu'):
				gen_counter+=1

		if gen_counter==nom_counter:
			return(True)
	return (False)

def noun_declination(number=None):
	'''
	Deklinacja rzeczownikow

	'''
	
	dec_1N_f=['a','ae','ae','am','a','a','ae','arum','is','as','is','ae']
	dec_2N_m=['us','i','o','um','o','e','i','orum','is','os','is','i']
	dec_2N_n=['um','i','o','um','o','um','a','orum','is','a','is','a']
	dec_3SPN_mf=['or','is','i','em','e','or','es','um','ibus','es','ibus','es']
	dec_3SPN_n=['','is','i','','e','','a','um','ibus','a','ibus','a']
	dec_3SGN_n=['','is','i','','i','e','ia','ium','ibus','ia','ibus','ia']
	dec_3MN_f1=['is','is','i','em','e','is','es','ium','ibus','es','ibus','es']
	dec_3MN_f2=['s','is','i','em','e','s','es','ium','ibus','es','ibus','es']
	dec_4N_m=['us','us','ui','um','u','us','us','uum','ibus','us','ibus','us']
	dec_4N_n=['u','us','u','u','u','u','ua','uum','ibus','ua','ibus','ua']
	dec_5N_f=['s','i','i','m','','s','s','rum','bus','s','bus','s']
	declination_return=[]
	err_genus=0
	
	if number!=None:
		shank,info=xml_split_line(xml_read_line(contest='all',number=number))
		nom=shank[0]
		gen=shank[1]
		declination=int(info[1])
		gender=info[2]
		if not(info[2]in('MNF')):err_genus=1
	else:
		return([-1])

		
#Declination:1
	if declination==1 and gender=='F':
		for i in range(12):
			declination_return.append(nom[:-1]+dec_1N_f[i])
#Declination:2
	if declination==2 and gender=='M' and nom[-2:]=='us':
		for i in range(12):
			declination_return.append(nom[:-2]+dec_2N_m[i])
	if declination==2 and gender=='M' and nom[-2:]=='er':
		for i in range(12):
			declination_return.append(nom+dec_2N_m[i])
		declination_return[0]=declination_return[5]=nom
	if declination==2 and gender=='N'and nom[-2:]=='um':
		for i in range(12):
			declination_return.append(nom[:-2]+dec_2N_n[i])
#Declination:3SP
	if declination==3 and gender=='M':
		for i in range(12):
			declination_return.append(gen[:-2]+dec_3SPN_mf[i])
		declination_return[0]=declination_return[5]=nom
	if declination==3 and gender=='F' and gen[-2:]=='is' and not(equal_sound(nom,gen)):
		for i in range(12):
			declination_return.append(gen[:-2]+dec_3SPN_mf[i])
		declination_return[0]=declination_return[5]=nom
	if declination==3 and gender=='N' and nom[-1:]!='e' and nom[-2:]!='al' and nom[-2:]!='er':
		for i in range(12):
			declination_return.append(gen[:-2]+dec_3SPN_n[i])
		declination_return[0]=declination_return[3]=declination_return[5]=nom
#Declination:3SG
	if declination==3 and gender=='N' and (nom[-1:]=='e' or nom[-2:]=='al' or nom[-2:]=='er'):
		for i in range(12):
			declination_return.append(gen[:-2]+dec_3SGN_n[i])
		declination_return[0]=declination_return[3]=declination_return[5]=nom
#Declination:3M
	if declination==3 and gender=='F' and (nom[-2:]=='is' or nom[-2:]=='es') and gen[-2:]=='is' and (equal_sound(nom,gen)):
		for i in range(12):
			declination_return.append(gen[:-2]+dec_3MN_f1[i])
	if declination==3 and gender=='F' and gen[-2:]=='is' and not(equal_sound(gen=gen)) and not(equal_sound(nom,gen)):
		for i in range(12):
			declination_return.append(gen[:-2]+dec_3MN_f2[i])
#Declination:4
	if declination==4 and gender=='M':
		for i in range(12):
			declination_return.append(nom[:-2]+dec_4N_m[i])
			declination_return[0]=nom
	if declination==4 and gender=='N':
		for i in range(12):
			declination_return.append(nom[:-1]+dec_4N_n[i])
			declination_return[0]=nom
#Declination:5
	if declination==5 and gender=='F':
		for i in range(12):
			declination_return.append(gen[:-1]+dec_5N_f[i])
			declination_return[0]=nom
#Returning
	if err_genus==1:
		return(-1,'error info(genus)')
	if err_genus==2:
		return(-1,'error info(declination)')
	if len(list(declination_return))!=12:
		#print info,len(list(declination_return)),nom,gen
		return(-1,'error count')
	return(declination_return,number,declination)


def adjective_declination(form_m=None, form_f=None, form_n=None, number=None, info=None, declination=None):
	'''
	Deklinacja przymiotnikow

	'''
	
	dec_1f=['a','ae','ae','am','a','a','ae','arum','is','as','is','ae']
	dec_2m=['us','i','o','um','o','e','i','orum','is','os','is','i']
	dec_2n=['um','i','o','um','o','um','o','orum','is','a','is','a']
	dec_31m=['','is','i','em','i','','es','ium','ibus','es','ibus','es']#-er, -is, -e
	dec_31f=['is','is','i','em','i','is','es','ium','ibus','es','ibus','es']#-er, -is, -e
	dec_31n=['e','is','i','e','i','e','ia','ium','ibus','ia','ibus','ia']#-er, -is, -e
	dec_32m=['is','is','i','em','i','is','es','ium','ibus','es','ibus','es']#-is, -is, -e
	dec_32f=['is','is','i','em','i','is','es','ium','ibus','es','ibus','es']#-is, -is, -e
	dec_32n=['e','is','i','e','i','e','ia','ium','ibus','ia','ibus','ia']#-is, -is, -e
	dec_33m=['','is','i','em','i','','es','ium','ibus','es','ibus','es']#-x, -x, -x
	dec_33f=['','is','i','es','i','','es','ium','ibus','es','ibus','es']#-x, -x, -x
	dec_33n=['','is','i','','i','','ia','ium','ibus','ia','ibus','ia']#-x, -x, -x
	declination_return=[]
	declination=0
	if declination==2:declination=1
	
	if number!=None:
		shank,info=xml_split_line(xml_read_line(contest='all',number=number))
		if len(shank)!=3:return(-1,'error declination')
		if '(' in shank[1]:return(-1,'error declination')
		form_m=shank[0]
		form_f=shank[1]
		form_n=shank[2]
		if '-um' in form_f:
			form_f=form_f[:-4]
			form_n=form_f[:-5]+'um'
#Declination:1,2
	if form_m[-2:]=='us' and form_f[-1:]=='a' and form_n[-2:]=='um':
		declination=1.0
		for i in range(12):#m
			declination_return.append(form_m[:-2]+dec_2m[i])
		for i in range(12):#f
			declination_return.append(form_f[:-1]+dec_1f[i])
		for i in range(12):#n
			declination_return.append(form_n[:-2]+dec_2n[i])
	if form_f[-2:]=='er' and form_f[-1:]=='a' and form_f[-2:]=='um':
		declination=1.1
		for i in range(12):#m
			declination_return.append(form_m[:-2]+dec_2m[i])
		for i in range(12):#f
			declination_return.append(form_f[:-1]+dec_1f[i])
		for i in range(12):#n
			declination_return.append(form_n[:-2]+dec_2n[i])
#Declination:31
	if form_m[-2:]=='er' and form_f[-2:]=='is' and form_n[-1:]=='e':
		declination=3.1
		for i in range(12):#m
			declination_return.append(form_m+dec_31m[i])
		for i in range(12):#f
			declination_return.append(form_f[:-2]+dec_31f[i])
		for i in range(12):#n
			declination_return.append(form_n[:-1]+dec_31n[i])
#Declination:32
	if form_m[-2:]=='is' and form_f[-2:]=='is' and form_n[-1:]=='e':
		declination=3.2
		for i in range(12):#m
			declination_return.append(form_m[:-2]+dec_32m[i])
		for i in range(12):#f
			declination_return.append(form_f[:-2]+dec_32f[i])
		for i in range(12):#n
			declination_return.append(form_n[:-1]+dec_32n[i])
#Declination:33
	if form_f=='(gen.)':
		declination=3.3
		for i in range(12):#m
			declination_return.append(form_n[:-2]+dec_33m[i])
		declination_return[0]=declination_return[5]=form_m
		for i in range(12):#f
			declination_return.append(form_n[:-2]+dec_33f[i])
		declination_return[0+12]=declination_return[5+12]=form_m
		for i in range(12):#n
			declination_return.append(form_n[:-2]+dec_33n[i])
		declination_return[0+24]=declination_return[5+24]=form_m
	if len(list(declination_return))!=36:
		#print info,len(list(declination_return)),form_m,form_f,form_n
		return(-1,'error declination')
	return(declination_return,number,declination)


							
def test(part_of_speech=None,percent=None):
	'''
	Test funkcji odmian sprawdzajaca ilosc poprawnie odmienianych czesci mowy
	
				noun                        adjective
	shift:  0                                   0
	count:  39223                           39223
	part:  18340 , 46 [%]                9062 , 23 [%]
	errors:  770 , 4 [%]                  633 , 6 [%] 
	time:  772 [s]                          747 [s]
	'''
	
	tic=time()
	shift=1
	errors=[]
	part=0
	count=int(float(percent)/100*GD.limit)

	if count==0: count=10
	print 30*'*'
	for i in range(count):
		exec ('ret_declination=('+part_of_speech+'_declination(number='+str(i+shift)+'))')
		if (ret_declination)==-1:
			pass
		else:
			part+=1
			if type(ret_declination)==str:
				errors.append(ret_declination)
				#print i+shift,ret_declination
			#if type(ret_declination)==list:print i+shift,ret_declination[0]
		if i%100==0:
			print '--',100*(i+shift)/count,'%'
	
	print '--',100,'%'
	print 30*'*'
	print 'shift: ',shift-1
	print 'count: ',count
	print 'part: ',part,',',(100*part)/count,'[%]'
	print 'errors: ',len(list(errors)),',',100*len(list(errors))/part,'[%]'
	print 'time: ',int(time()-tic),'[s]'
	print 30*'*'
	#test('adjective',1)
	
def random_question(part=None, declination=1, affinity=1, coniugation=1):

	tic=time()
	if part=='N':part_of_speech='noun'
	if part=='V':part_of_speech='verb'
	if part=='ADJ':part_of_speech='adjective'
	if declination==2 and part=='ADJ':declination=1
	
	number=randint(1,GD.limit)
	for i in range(GD.limit):
		if number<GD.limit:
			number+=1
			shank,info=xml_split_line(xml_read_line(contest='all',number=number))

			if info[0]=='N'==part and info[1]==str(declination):
				exec ('ret_declination=('+part_of_speech+'_declination(number='+str(number)+'))')
				if (ret_declination[0])!=-1:
					if int(ret_declination[2])==declination:
						return(number)
			if info[0]=='ADJ'==part:
				exec ('ret_declination=('+part_of_speech+'_declination(number='+str(number)+'))')
				if (ret_declination[0])!=-1:
					if int(ret_declination[2])==declination:
						return(number)
			if info[0]=='V'==part and info[1]==str(declination) and len(shank)>1:
				return(number)  
		else:
			number=0
		#print 'VVV2', 'part',part,'coniugation',coniugation,type(coniugation)
		if float(time()-tic)>=GD.timeSearchQuestion:
			
			print 'NON DYNAMIK GENER'

			N1_rand_tab=GD.N1_rand_tab
			N2_rand_tab=GD.N2_rand_tab
			N3_rand_tab=GD.N3_rand_tab
			N4_rand_tab=GD.N4_rand_tab
			N5_rand_tab=GD.N5_rand_tab
			J1_rand_tab=GD.J1_rand_tab
			J3_rand_tab=GD.J3_rand_tab
			V1_rand_tab=GD.V1_rand_tab
			V2_rand_tab=GD.V2_rand_tab
			V3_rand_tab=GD.V3_rand_tab
			V4_rand_tab=GD.V4_rand_tab
			if part=='N':
				if str(declination)==str(1):return(N1_rand_tab[randint(0,len(N1_rand_tab)-1)])
				if str(declination)==str(2):return(N2_rand_tab[randint(0,len(N2_rand_tab)-1)])
				if str(declination)==str(3):return(N3_rand_tab[randint(0,len(N3_rand_tab)-1)])
				if str(declination)==str(4):return(N4_rand_tab[randint(0,len(N4_rand_tab)-1)])
				if str(declination)==str(5):return(N5_rand_tab[randint(0,len(N5_rand_tab)-1)])
			if part=='ADJ':
				if str(declination)==str(1):return(J1_rand_tab[randint(0,len(J1_rand_tab)-1)])
				if str(declination)==str(3):return(J3_rand_tab[randint(0,len(J3_rand_tab)-1)])
			if part=='V':
				if str(coniugation)==str(1):return(V1_rand_tab[randint(0,len(V1_rand_tab)-1)])
				if str(coniugation)==str(2):return(V2_rand_tab[randint(0,len(V2_rand_tab)-1)])
				if str(coniugation)==str(3):return(V3_rand_tab[randint(0,len(V3_rand_tab)-1)])
				if str(coniugation)==str(4):return(V4_rand_tab[randint(0,len(V4_rand_tab)-1)])
	 

def con_con(part=None, declination=2):
	if part=='N':
		ret=(noun_declination(number=random_question(part='N',declination=declination)))
		#print len(ret)
		return(ret)
	if part=='ADJ':
		ret=(adjective_declination(number=random_question(part='ADJ',declination=declination)))
		#print len(ret)
		return(ret)
	if part=='V':
		ret=(verb_coniugation(number=random_question(part='V',declination=declination)))
		#print len(ret[1])
		return(ret)


#<h17 lat="abalieno, abalienare, abalienavi, abalienatus" info="[V,1,TRANS,XXXBS]"></h17>

def verb_coniugation(form_1=None, form_2=None, form_3=None, form_4=None, number=None, info=None, coniugation=None):
	

	if number!=None:
		shank,info=xml_split_line(xml_read_line(contest='all',number=number))
		core=shank[1][:-3]
		#print info
	else:
		return(None)
		

	con_1_praesentis=[
			'o','as','at','amus','atis','ant',#Indicativus
			'em','es','et','emus','etis','ent',#Coniunctivus
			'-','a','-','-','ate','-',#Imperativus
			'-','-','ans','-','-','-',#Participium
			'-','-','are','-','-','-',#Infinitivus
			'or','aris','atur','amur','amini','antur',#Indicativus
			'er','eris','etur','emur','emini','entur',#Coniunctivus
			'-','are','-','-','amini','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'-','-','ari','-','-','-']#Infinitivus
	con_1_imperfecti=[#60
			'abam','abas','abat','abamus','abatis','abant',#Indicativus
			'arem','ares','aret','aremus','aretis','arent',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'-','-','-','-','-','-',#Infinitivus
			'abar','abaris','abatur','abamur','abamini','abantur',#Indicativus
			'arer','areris','aretur','aremur','aremini','arentur',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'-','-','-','-','-','-']#Infinitivus
	con_1_futurum1=[#120
			'abo','abis','abit','abimus','abitis','abunt',#Indicativus
			'-','-','-','-','-','-',#Coniunctivus
			'-','ato','ato','-','atote','anto',#Imperativus
			'aturus','-','-','-','-','-',#Participium
			'aturus','-','-','-','-','-',#Infinitivus
			'abor','aberis','abitur','abimur','abimini','abuntur',#Indicativus
			'-','-','-','-','-','-',#Coniunctivus
			'-','ator','ator','-','-','antor',#Imperativus
			'-','-','andus','-','-','-',#Participium
			'atum','-','-','-','-','-']#Infinitivus
	con_1_perfecti=[#180
			'avi','avisti','avit','avimus','avistis','averunt',#Indicativus
			'averim','averis','averit','averimus','averitis','averint',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'avisse','-','-','-','-','-',#Infinitivus
			'atus','-','-','ati','-','-',#Indicativus
			'atus','-','-','ati','-','-',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','atus','-','-','-',#Participium
			'atus','-','-','-','-','-']#Infinitivus
	con_1_plusquam_perfecti=[#240
			'averam','averas','averat','averamus','averatis','averant',#Indicativus
			'avissem','avisses','avisset','avissemus','avissetis','avissent',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'-','-','-','-','-','-',#Infinitivus
			'atus','-','-','ati','-','-',#Indicativus
			'atus','-','-','ati','-','-',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'-','-','-','-','-','-']#Infinitivus
	con_1_futuri_exacti=[#300
			'avero','averis','averit','averimus','averitis','averint',#Indicativus
			'-','-','-','-','-','-',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'-','-','-','-','-','-',#Infinitivus
			'atus','-','-','ati','-','-',#Indicativus
			'-','-','-','-','-','-',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'-','-','-','-','-','-']#Infinitivus
	con_2_praesentis=[#360
			'eo','es','et','emus','etis','ent',#Indicativus
			'eam','eas','eat','eamus','eatis','eant',#Coniunctivus
			'-','e','-','-','ete','-',#Imperativus
			'-','-','ens','-','-','-',#Participium
			'-','-','ere','-','-','-',#Infinitivus
			'eor','eris','etur','emur','emini','entur',#Indicativus
			'ear','earis','eatur','eamur','eamini','eantur',#Coniunctivus
			'-','ere','-','-','emini','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'-','-','eri','-','-','-']#Infinitivus
	con_2_imperfecti=[
			'ebam','ebas','ebat','ebamus','ebatis','ebant',#Indicativus
			'erem','eres','eret','eremus','eretis','erent',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'-','-','-','-','-','-',#Infinitivus
			'ebar','ebaris','ebatur','ebamur','ebamini','ebantur',#Indicativus
			'erer','ereris','eretur','eremur','eremini','erentur',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'-','-','-','-','-','-']#Infinitivus
	con_2_futurum1=[
			'ebo','ebis','ebit','ebimus','ebitis','ebunt',#Indicativus
			'-','-','-','-','-','-',#Coniunctivus
			'-','eto','eto','-','etote','ento',#Imperativus
			'eturus','-','-','-','-','-',#Participium
			'eturus','-','-','-','-','-',#Infinitivus
			'ebor','eberis','ebitur','ebimur','ebimini','ebuntur',#Indicativus
			'-','-','-','-','-','-',#Coniunctivus
			'-','etor','etor','-','-','ntor',#Imperativus
			'-','-','endus','-','-','-',#Participium
			'etum','-','-','-','-','-']#Infinitivus
	con_2_perfecti=[
			'evi','evisti','evit','evimus','evistis','everunt',#Indicativus
			'everim','everis','everit','everimus','everitis','everint',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'evisse','-','-','-','-','-',#Infinitivus
			'etus','-','-','eti','-','-',#Indicativus
			'etus','-','-','eti','-','-',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','etus','-','-','-',#Participium
			'etus','-','-','-','-','-']#Infinitivus
	con_2_plusquam_perfecti=[
			'everam','everas','everat','everamus','everatis','everant',#Indicativus
			'evissem','evisses','evisset','evissemus','evissetis','evissent',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'-','-','-','-','-','-',#Infinitivus
			'etus','-','-','eti','-','-',#Indicativus
			'etus','-','-','eti','-','-',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'-','-','-','-','-','-']#Infinitivus
	con_2_futuri_exacti=[
			'evero','everis','everit','everimus','everitis','everint',#Indicativus
			'-','-','-','-','-','-',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'-','-','-','-','-','-',#Infinitivus
			'etus','-','-','eti','-','-',#Indicativus
			'-','-','-','-','-','-',#Coniunctivus
			'-','-','-','-','-','-',#Imperativus
			'-','-','-','-','-','-',#Participium
			'-','-','-','-','-','-']#Infinitivus
	con_3_praesentis=[
		'o','is','it','imus','itis','unt',#Indicativus
		'am','as','at','amus','atis','ant',#Coniunctivus
		'-','e','-','-','ite','-',#Imperativus
		'-','-','ens','-','-','-',#Participium
		'-','-','ere','-','-','-',#Infinitivus
		'or','eris','itur','imur','imini','untur',#Indicativus
		'ar','aris','atur','amur','amini','antur',#Coniunctivus
		'-','ere','-','-','imini','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'-','-','i','-','-','-']#Infinitivus
	con_3_imperfecti=[       
		'ebam','ebas','ebat','ebamus','ebatis','ebant',#Indicativus
		'erem','eres','eret','eremus','eretis','erent',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'-','-','-','-','-','-',#Infinitivus
		'ebar','ebaris','ebatur','ebamur','ebamini','ebantur',#Indicativus
		'erer','ereris','eretur','eremur','eremini','erentur',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'-','-','-','-','-','-']#Infinitivus
	con_3_futurum1=[
		'am','es','et','emus','etis','ent',#Indicativus
		'-','-','-','-','-','-',#Coniunctivus
		'-','ito','ito','-','itote','unto',#Imperativus
		'turus','-','-','-','-','-',#Participium
		'turus','-','-','-','-','-',#Infinitivus
		'ar','eris','etur','emur','emini','entur',#Indicativus
		'-','-','-','-','-','-',#Coniunctivus
		'-','itor','itor','-','-','untor',#Imperativus
		'-','-','endus','-','-','-',#Participium
		'tum','-','-','-','-','-']#Infinitivus
	con_3_perfecti=[
		'i','isti','it','imus','istis','erunt',#Indicativus
		'erim','eris','erit','erimus','eritis','erint',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'isse','-','-','-','-','-',#Infinitivus
		'tus','-','-','ti','-','-',#Indicativus
		'tus','-','-','ti','-','-',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','tus','-','-','-',#Participium
		'tus','-','-','-','-','-']#Infinitivus
	con_3_plusquam_perfecti=[
		'eram','eras','erat','eramus','eratis','erant',#Indicativus
		'issem','isses','isset','issemus','issetis','issent',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'-','-','-','-','-','-',#Infinitivus
		'tus','-','-','ti','-','-',#Indicativus
		'tus','-','-','ti','-','-',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'-','-','-','-','-','-']#Infinitivus
	con_3_futuri_exacti=[
		'ero','eris','erit','erimus','eritis','erint',#Indicativus
		'-','-','-','-','-','-',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'-','-','-','-','-','-',#Infinitivus
		'tus','-','-','ti','-','-',#Indicativus
		'-','-','-','-','-','-',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'-','-','-','-','-','-']#Infinitivus
	con_4_praesentis=[
		'io','is','it','imus','itis','iunt',#Indicativus
		'iam','ias','iat','iamus','iatis','iant',#Coniunctivus
		'-','i','-','-','ite','-',#Imperativus
		'-','-','iens','-','-','-',#Participium
		'-','-','ire','-','-','-',#Infinitivus
		'ior','iris','itur','imur','imini','iuntur',#Indicativus
		'iar','iaris','iatur','iamur','iamini','iantur',#Coniunctivus
		'-','ire','-','-','imini','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'-','-','iri','-','-','-']#Infinitivus
	con_4_imperfecti=[
		'iebam','iebas','iebat','iebamus','iebatis','iebant',#Indicativus
		'irem','ires','iret','iremus','iretis','rient',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'-','-','-','-','-','-',#Infinitivus
		'iebar','iebaris','iebatur','iebamur','iebamini','iebantur',#Indicativus
		'irer','ireris','iretur','iremur','iremini','irentur',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'-','-','-','-','-','-']#Infinitivus
	con_4_futurum1=[
		'iam','ies','iet','iemus','ietis','ient',#Indicativus
		'-','-','-','-','-','-',#Coniunctivus
		'-','ito','ito','-','itote','iunto',#Imperativus
		'iturus','-','-','-','-','-',#Participium
		'iturus','-','-','-','-','-',#Infinitivus
		'iar','ieris','ietur','iemur','iemini','ientur',#Indicativus
		'-','-','-','-','-','-',#Coniunctivus
		'-','itor','itor','-','-','iuntor',#Imperativus
		'-','-','iendus','-','-','-',#Participium
		'itum','-','-','-','-','-']#Infinitivus
	con_4_perfecti=[
		'ivi','ivisti','ivit','ivimus','ivistis','iverunt',#Indicativus
		'iverim','iveris','iverit','iverimus','iveritis','iverint',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'isse','-','-','-','-','-',#Infinitivus
		'itus','-','-','iti','-','-',#Indicativus
		'itus','-','-','iti','-','-',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','itus','-','-','-',#Participium
		'itus','-','-','-','-','-']#Infinitivus
	con_4_plusquam_perfecti=[
		'iveram','iveras','iverat','iveramus','iveratis','iverant',#Indicativus
		'ivissem','ivisses','ivisset','ivissemus','ivissetis','ivissent',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'-','-','-','-','-','-',#Infinitivus
		'itus','-','-','iti','-','-',#Indicativus
		'itus','-','-','iti','-','-',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'-','-','-','-','-','-']#Infinitivus
	con_4_futuri_exacti=[
		'ivero','iveris','iverit','iverimus','iveritis','iverint',#Indicativus
		'-','-','-','-','-','-',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'-','-','-','-','-','-',#Infinitivus
		'itus','-','-','iti','-','-',#Indicativus
		'-','-','-','-','-','-',#Coniunctivus
		'-','-','-','-','-','-',#Imperativus
		'-','-','-','-','-','-',#Participium
		'-','-','-','-','-','-']#Infinitivus
	if info[1]=='1':
		for i in con_1_praesentis:
			if i!='-':
				con_1_praesentis[con_1_praesentis.index(i)]=core+i
				
		for i in con_1_imperfecti:
			if i!='-':
				con_1_imperfecti[con_1_imperfecti.index(i)]=core+i
				
		for i in con_1_futurum1:
			if i!='-':
				con_1_futurum1[con_1_futurum1.index(i)]=core+i
				
		for i in con_1_perfecti:
			if i!='-':
				con_1_perfecti[con_1_perfecti.index(i)]=core+i
				
		for i in con_1_plusquam_perfecti:
			if i!='-':
				con_1_plusquam_perfecti[con_1_plusquam_perfecti.index(i)]=core+i
				
		for i in con_1_futuri_exacti:
			if i!='-':
				con_1_futuri_exacti[con_1_futuri_exacti.index(i)]=core+i
				
		ret_con=[con_1_praesentis,con_1_imperfecti,con_1_futurum1,
					con_1_perfecti,con_1_plusquam_perfecti,con_1_futuri_exacti]
	
		return(ret_con,number,'1')

	if info[1]=='2':
		for i in con_2_praesentis:
			if i!='-':
				con_2_praesentis[con_2_praesentis.index(i)]=core+i
				
		for i in con_2_imperfecti:
			if i!='-':
				con_2_imperfecti[con_2_imperfecti.index(i)]=core+i
				
		for i in con_2_futurum1:
			if i!='-':
				con_2_futurum1[con_2_futurum1.index(i)]=core+i
				
		for i in con_2_perfecti:
			if i!='-':
				con_2_perfecti[con_2_perfecti.index(i)]=core+i
				
		for i in con_2_plusquam_perfecti:
			if i!='-':
				con_2_plusquam_perfecti[con_2_plusquam_perfecti.index(i)]=core+i
				
		for i in con_2_futuri_exacti:
			if i!='-':
				con_2_futuri_exacti[con_2_futuri_exacti.index(i)]=core+i
				
		ret_con=[con_2_praesentis,con_2_imperfecti,con_2_futurum1,
					con_2_perfecti,con_2_plusquam_perfecti,con_2_futuri_exacti]

		return(ret_con,number,'2')

	if info[1]=='3':
		for i in con_3_praesentis:
			if i!='-':
				con_3_praesentis[con_3_praesentis.index(i)]=core+i
				
		for i in con_3_imperfecti:
			if i!='-':
				con_3_imperfecti[con_3_imperfecti.index(i)]=core+i
				
		for i in con_3_futurum1:
			if i!='-':
				con_3_futurum1[con_3_futurum1.index(i)]=core+i
				
		for i in con_3_perfecti:
			if i!='-':
				con_3_perfecti[con_3_perfecti.index(i)]=core+i
				
		for i in con_3_plusquam_perfecti:
			if i!='-':
				con_3_plusquam_perfecti[con_3_plusquam_perfecti.index(i)]=core+i
				
		for i in con_3_futuri_exacti:
			if i!='-':
				con_3_futuri_exacti[con_3_futuri_exacti.index(i)]=core+i
				
		ret_con=[con_3_praesentis,con_3_imperfecti,con_3_futurum1,
					con_3_perfecti,con_3_plusquam_perfecti,con_3_futuri_exacti]

		return(ret_con,number,'3')

	if info[1]=='4':
		for i in con_4_praesentis:
			if i!='-':
				con_4_praesentis[con_4_praesentis.index(i)]=core+i
				
		for i in con_4_imperfecti:
			if i!='-':
				con_4_imperfecti[con_4_imperfecti.index(i)]=core+i
				
		for i in con_4_futurum1:
			if i!='-':
				con_4_futurum1[con_4_futurum1.index(i)]=core+i
				
		for i in con_4_perfecti:
			if i!='-':
				con_4_perfecti[con_4_perfecti.index(i)]=core+i
				
		for i in con_4_plusquam_perfecti:
			if i!='-':
				con_4_plusquam_perfecti[con_4_plusquam_perfecti.index(i)]=core+i
				
		for i in con_4_futuri_exacti:
			if i!='-':
				con_4_futuri_exacti[con_4_futuri_exacti.index(i)]=core+i
				
		ret_con=[con_4_praesentis,con_4_imperfecti,con_4_futurum1,
					con_4_perfecti,con_4_plusquam_perfecti,con_4_futuri_exacti]

		return(ret_con,number,'4')
		
#verb_coniugation(number=random_question('V','1'))
#for i in range(1):
#	pass
#print (con_con('V',declination=4))
def a():
	pass
	#for x in range(50):
	#	a=verb_coniugation(number=GD.V4_rand_tab[x])
		#print x, GD.V4_rand_tab[x]
	#	if len(a)==2: print x, a, GD.V4_rand_tab[x]
	

	
