# coding: UTF-8
# xml.base.handling.py
#
# library for: Cicero Open Project
# 

# PROGRAM CONSTATNTS
__version__='1.0.0'
__license__='GPL'
__author__='Cicero Develop Team'
__site__='www.cicero.glt.pl'

# IMPORTS
import string
import sys
import global_direct as GD
from string import find, rsplit

# GLOBAL VARIABLES



   
def xml_load_base(file_name=GD.xml_file_lat_name):
    """
    xml_load_base
    Funkcja odczytuje z pliku file_name baze xml, istotne parametry bazy
    i sama tresc bazy po czym zwraca informance w formie tabeli
    """
    try:
        xml_handle=open(file_name,'r')
        xml_contest=xml_handle.read()
        xml_base= {'contest': xml_contest,
                                'xml_version': xml_contest[string.find(xml_contest,'version="')+9:string.find(xml_contest,'"',string.find(xml_contest,'version="')+9)],
                                'encoding': xml_contest[string.find(xml_contest,'encoding="')+10:string.find(xml_contest,'"',string.find(xml_contest,'encoding="')+10)],
                                'info': xml_contest[string.find(xml_contest,'info="')+6:string.find(xml_contest,'"',string.find(xml_contest,'info="')+6)],
                                'language': xml_contest[string.find(xml_contest,'language="')+10:string.find(xml_contest,'"',string.find(xml_contest,'language="')+10)],
                                'date': xml_contest[string.find(xml_contest,'date="')+6:string.find(xml_contest,'"',string.find(xml_contest,'date="')+6)],
                                'counter': 39224}
        xml_handle.close()
        return(xml_base)
    except IOError, (errno, strerror):
        print "Read file error(xml_load_base)(" + str(sys.exc_info()[0]) + ")"
        print GD.xml_file_lat_name
    except ValueError:
        print "Base orgazniation error(xml_load_base)(" + str(sys.exc_info()[0]) + ")" 
    except:
        print "Unidentified error(xml_load_base)(" + str(sys.exc_info()[0]) + ")" 
    return(-1)

def xml_read_line(file_name=GD.xml_file_lat_name, contest='all',number=0):
    """
    xml_read_line()
    Funkcja odczytuje z pliku file_name wpis o podanym numerze,
    a nastepnie zwraca calosc lub czesc lini wskazaej w parametrze
    """
    if number>GD.limit or number <1:
        return(-1)
    xml_base=xml_load_base(file_name)
    start=find(xml_base['contest'],'h'+str(number)+' ')-1
    end=find(xml_base['contest'],'h'+str(number)+'>',start)+len(str(number))+2
    ret_all=xml_base['contest'][start:end]
    if len(ret_all)<2:
		start=find(xml_base['contest'],'h'+str(number)+' ')-1
		end=find(xml_base['contest'],'/>',start)+2
		ret_all=xml_base['contest'][start:end]
    if contest=='all':
        return(ret_all)
    if contest=='shank':
        start=find(ret_all,'lat="')+5
        end=find(ret_all,'"',start+1)
        ret_shank=ret_all[start:end]
        return(ret_shank)
    if contest=='info':
        start=find(ret_all,'info="')+6
        end=find(ret_all,'"',start+1)
        ret_info=ret_all[start:end]
        return(ret_info)

def xml_split_line(line=None, baze='normal'):
	if baze=='normal':
		start=find(line,'="')+2
		end=find(line,'"',start+1)
		shank=line[start:end]
		start=find(line,'="',end+1)+2
		end=find(line,'"',start+1)
		info=line[start:end]
		return(rsplit(shank,', '),rsplit(info[1:-1],','))
	if baze=='triBaze':
		lat=find(line,'lat=')+5
		eng=find(line,'eng=')+5
		pol=find(line,'pol=')+5
		end=find(line,'/>')
		return([line[lat:eng-11],line[eng:pol-7],line[pol:end-1]])

#TODO:
